-- ========================================================================== --
-- 										 EskaQuestTracker                                       --
-- @Author   : Skamer <https://mods.curse.com/members/DevSkamer>              --
-- @Website  : https://wow.curseforge.com/projects/eska-quest-tracker         --
-- ========================================================================== --
import "System"
-- ========================================================================== --
namespace "EQT"
-- ========================================================================== --
-- __DBTextOptions__(dbTable, hasMultipleFonts)
__AttributeUsage__{ AttributeTarget = AttributeTargets.Class, RunOnce = true, BeforeDefinition = true }
  class "__DBTextOptions__" (function(_ENV)
    extend "IAttribute"

    _TMP_DB_TABLE = nil
    _TMP_DB_HAS_MULTIPLE_FONTS = nil
    _CLASSES_DB_TABLE = {}

    local function GetDB(class)
      local db = _CLASSES_DB_TABLE[class]
      if type(db) == "function" then
        db = db()
      end
      return db
    end

    function ApplyAttribute(target, targetType)
      _CLASSES_DB_TABLE[targetType] = _TMP_DB_TABLE

      if _TMP_DB_HAS_MULTIPLE_FONTS then

        __Static__()
        function targetType:SetTextSize(index, size)
          GetDB(self).textSizes[index] = size
          if self.RefreshAll then self:RefreshAll() end
        end

        __Static__()
        function targetType:GetTextSize(index)
          return GetDB(self).textSizes[index]
        end

        __Static__()
        function targetType:SetTextFont(index, font)
          GetDB(self).textFonts[index] = font
          if self.RefreshAll then self:RefreshAll() end
        end

        __Static__()
        function targetType:GetTextFont(index)
          return  GetDB(self).textFonts[index]
        end

        __Static__()
        function targetType:SetTextColor(index, color)
          GetDB(self).textColors[index] = color
          if self.RefreshAll then self:RefreshAll() end
        end

        __Static__()
        function targetType:GetTextColor(index)
          return GetDB(self).textColors[index]
        end

        __Static__()
        function targetType:SetTextTransform(index, transform)
          GetDB(self).textTransforms[index] = transform
          if self.RefreshAll then self:RefreshAll() end
        end

        __Static__()
        function targetType:GetTextTransform(index)
          return  GetDB(self).textTransforms[index]
        end

      else
        targetType.textSize = __Static__ {
          TYPE = System.Number,
          GET = function(self) return GetDB(self).textSize end,
          SET = function(self, size) GetDB(self).textSize = size
            if self.RefreshAll then self:RefreshAll() end
          end
        }

        targetType.textFont = __Static__ {
          TYPE = System.String,
          GET = function(self) return GetDB(self).textFont end,
          SET = function(self, font) GetDB(self).textFont = font
            if self.RefreshAll then self:RefreshAll() end
          end
        }

        targetType.textColor = __Static__ {
          TYPE = System.Any,
          GET = function(self) return  GetDB(self).textColor end,
          SET = function(self, color) GetDB(self).textColor = color
            if self.RefreshAll then self:RefreshAll() end
          end
        }

        targetType.textTransform = __Static__ {
          TYPE = System.String,
          GET = function(self) return GetDB(self).textTransform end,
          SET = function(self, transform) GetDB(self).textTransform = transform
            if self.RefreshAll then self:RefreshAll() end
          end,
        }
      end

    end

    __Arguments__{ Table + Function, Argument(Boolean, true, true, "hasMultipleFonts")}
    function __DBTextOptions__(self, dbTable, hasMultipleFonts)
      _TMP_DB_TABLE = dbTable
      _TMP_DB_HAS_MULTIPLE_FONTS = hasMultipleFonts
    end

  end)
